import { Keyboard, createShortcuts, stringifyKey } from "./index";
describe("keyboard manager", function () {
    it("should manage keyboard shortcuts", function () {
        var _a;
        var triggered = 0;
        var keyboard = new Keyboard();
        var event1 = { key: "a", metaKey: true };
        var event2 = { key: "0" };
        var handler = keyboard.getHandler();
        var listener = createShortcuts((_a = {},
            _a[stringifyKey("cmd", "a")] = function () {
                triggered++;
            },
            _a));
        keyboard.addListener(listener);
        handler(event1);
        handler(event2);
        keyboard.removeListener(listener);
        handler(event1);
        handler(event2);
        expect(triggered).toEqual(1);
    });
    it('should support a "global" pattern', function () {
        var _a, _b;
        var dispatcher = new Keyboard();
        var handler = dispatcher.getHandler();
        var appTriggered = 0;
        var globalTriggered = 0;
        var appKeyboard = new Keyboard();
        var globalKeyboard = new Keyboard();
        dispatcher.addListener(appKeyboard.getListener());
        dispatcher.addListener(globalKeyboard.getListener());
        globalKeyboard.addListener(createShortcuts((_a = {},
            _a[stringifyKey("cmd", "a")] = function () {
                globalTriggered++;
            },
            _a)));
        appKeyboard.addListener(createShortcuts((_b = {},
            _b[stringifyKey("a")] = function () {
                appTriggered++;
            },
            _b[stringifyKey("cmd", "a")] = function () {
                appTriggered++;
            },
            _b)));
        handler({ key: "a", metaKey: true });
        expect(appTriggered).toEqual(0);
        expect(globalTriggered).toEqual(1);
        handler({ key: "a" });
        expect(appTriggered).toEqual(1);
        expect(globalTriggered).toEqual(1);
    });
});
//# sourceMappingURL=index.spec.js.map